#ifndef GAMESERVER_IMPL_H
#define GAMESERVER_IMPL_H

#include <Game_skel.h>

class GameServer_impl : public POA_GameServer,
			public PortableServer::RefCountServantBase
{
  //
  // The ORB
  //
  CORBA::ORB_var orb_;

  //
  // The servants default POA
  //
  PortableServer::POA_var poa_;

  public:

  GameServer_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr poa);

  ~GameServer_impl();

  Game_ptr 
    join_game( ::CORBA::ULong_out player_id,
	       ::CORBA::ULong_out game_id )
    throw(CORBA::SystemException);

  Game_ptr 
    retry( ::CORBA::ULong player_id,
	   ::CORBA::ULong game_id )
    throw(CORBA::SystemException);
  
  virtual PortableServer::POA_ptr
    _default_POA();
};

#endif
