// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************


/************
 * INCLUDES *
 ************/

// CORBA includes
#include <OB/CORBA.h>

// project includes
#include <Game_impl.h>
#include "sql_lib.h"


#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

// ----------------------------------------------------------------------
// Game_impl constructor
// ----------------------------------------------------------------------

Game_impl::Game_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr poa)
    : orb_(CORBA::ORB::_duplicate(orb)), 
      poa_(PortableServer::POA::_duplicate(poa))
{
  // connect the database
  borba_connect();

  // create the database table -- this returns an error if the table already
  // exists so be sure to fix this in the future
  borba_setup_tables();

  // insert a dummy value into the table
  borba_insert(0, -1);
}

// ----------------------------------------------------------------------
// Game_impl constructor
// ----------------------------------------------------------------------

Game_impl::~Game_impl() {
  borba_disconnect();
}

// ----------------------------------------------------------------------
// Game_impl public member implementation
// ----------------------------------------------------------------------

struct GameState
Game_impl::update( const struct ClientAction &arg1 )
    throw(CORBA::SystemException)
{
  struct GameState retval;
  cout << "Received arrow key: " << arg1.arrow << endl;  
  retval.errval = arg1.arrow;

  // write the arrow key to the database
  borba_update(0, (int)arg1.arrow);
  
  return retval;
}

void
Game_impl::shutdown()
    throw(CORBA::SystemException)
{
    orb_ -> shutdown(false);
}

PortableServer::POA_ptr
Game_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}

