#ifndef GAME_IMPL_H
#define GAME_IMPL_H

#include <Game_skel.h>
#include <Game.h>

class Game_impl : public POA_Game,
                  public PortableServer::RefCountServantBase
{
  private:
    // The ORB
    CORBA::ORB_var orb_;

    // The servants default POA
    PortableServer::POA_var poa_;

    // current game state to send back to clients
    struct GameState gs;

    // initialize the game state each round
    void init_round();

    // convert the text version of the map to/from the array version in gs
    void map_str_to_array(char *map_str);
    void map_array_to_str(char *map_str);  // caller must allocate buffer

    // get the PlayerInfo struct that corresponds to the give player ID
    struct PlayerInfo* get_player(unsigned int pid);

  public:

    Game_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr poa, 
              CORBA::ULong game_id);

    ~Game_impl();

    struct GameState Game_impl::update(const struct ClientAction &c_action)
      throw (CORBA::SystemException);

    long Game_impl::exit_game(CORBA::ULong player_id, CORBA::ULong game_id)
      throw (CORBA::SystemException);

    bool Game_impl::is_game_started(CORBA::ULong player_id, 
                                    CORBA::ULong game_id)
      throw (CORBA::SystemException);

    long Game_impl::get_id()
      throw (CORBA::SystemException);

    virtual PortableServer::POA_ptr _default_POA();
};
#endif

