#ifndef __SQL_LIB_H__
#define __SQL_LIB_H__

int connect_to_database();
int disconnect_database();
int create_tables();

// Returns game id of latest waiting game or -1 if it is active
int check_games();

// Returns id of newly-created game
int create_game();

// Returns id of newly-created player
// FIX: NEED TO CHECK FOR CONCURRENCY
int create_player(int game_id, int x_coord, int y_coord);

int move_player(int game_id, int player_id, int x_coord, int y_coord);

// FIX: DOES NOT STORE TIMELEFT YET
int plant_bomb(int game_id, int player_id, int x_coord, int y_coord);

// For atomic transactions:
// BEGIN will start a transaction
// COMMIT will commit all queries since BEGIN
// ROLLBACK will end transaction; all queries since BEGIN are lost
int begin_transaction();
int commit_transaction();
int rollback_transaction();


#endif
